/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "rcfile_y.y" /* yacc.c:339  */

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"
#include "fetchmail.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "i18n.h"
#include "rcfile_l.h"
  
/* parser reads these */
char *rcfile;			/* path name of rc file */
extern struct query cmd_opts;	/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

static void yywarn(const char *);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* lexer interface */
extern int prc_lineno;

static void yywarn(const char *s)
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s, 
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
}

void yyerror (const char *s)
/* report a syntax error */
{
    yywarn(s);
    prc_errflag++;
}


#line 127 "rcfile_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_RCFILE_Y_H_INCLUDED
# define YY_YY_RCFILE_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DEFAULTS = 258,
    POLL = 259,
    SKIP = 260,
    VIA = 261,
    AKA = 262,
    LOCALDOMAINS = 263,
    PROTOCOL = 264,
    AUTHENTICATE = 265,
    TIMEOUT = 266,
    KPOP = 267,
    SDPS = 268,
    ENVELOPE = 269,
    QVIRTUAL = 270,
    PINENTRY_TIMEOUT = 271,
    PWMD_SOCKET = 272,
    PWMD_SOCKET_ARGS = 273,
    PWMD_FILE = 274,
    IDLETIMEOUT = 275,
    USERNAME = 276,
    PASSWORD = 277,
    FOLDER = 278,
    SMTPHOST = 279,
    FETCHDOMAINS = 280,
    MDA = 281,
    BSMTP = 282,
    LMTP = 283,
    PASSWORDFILE = 284,
    PASSWORDFD = 285,
    PASSWORDEVAL = 286,
    SMTPADDRESS = 287,
    SMTPNAME = 288,
    SPAMRESPONSE = 289,
    PRECONNECT = 290,
    POSTCONNECT = 291,
    LIMIT = 292,
    WARNINGS = 293,
    INTERFACE = 294,
    MONITOR = 295,
    PLUGIN = 296,
    PLUGOUT = 297,
    IS = 298,
    HERE = 299,
    THERE = 300,
    TO = 301,
    MAP = 302,
    BATCHLIMIT = 303,
    FETCHLIMIT = 304,
    FETCHSIZELIMIT = 305,
    FASTUIDL = 306,
    EXPUNGE = 307,
    PROPERTIES = 308,
    SET = 309,
    LOGFILE = 310,
    DAEMON = 311,
    SYSLOG = 312,
    IDFILE = 313,
    PIDFILE = 314,
    INVISIBLE = 315,
    POSTMASTER = 316,
    BOUNCEMAIL = 317,
    SPAMBOUNCE = 318,
    SOFTBOUNCE = 319,
    SHOWDOTS = 320,
    BADHEADER = 321,
    ACCEPT = 322,
    REJECT_ = 323,
    RETRIEVEERROR = 324,
    ABORT = 325,
    CONTINUE = 326,
    MARKSEEN = 327,
    PROTO = 328,
    AUTHTYPE = 329,
    STRING = 330,
    NUMBER = 331,
    NO = 332,
    KEEP = 333,
    FLUSH = 334,
    LIMITFLUSH = 335,
    FETCHALL = 336,
    REWRITE = 337,
    FORCECR = 338,
    STRIPCR = 339,
    PASS8BITS = 340,
    DROPSTATUS = 341,
    DROPDELIVERED = 342,
    FORCEIDLE = 343,
    DNS = 344,
    SERVICE = 345,
    PORT = 346,
    UIDL = 347,
    INTERVAL = 348,
    MIMEDECODE = 349,
    IDLE = 350,
    CHECKALIAS = 351,
    SSL_ = 352,
    SSLKEY = 353,
    SSLCERT = 354,
    SSLMODE = 355,
    SSLPROTOVER = 356,
    SSLCERTCK = 357,
    SSLCERTFILE = 358,
    SSLCERTPATH = 359,
    SSLCOMMONNAME = 360,
    SSLFINGERPRINT = 361,
    PRINCIPAL = 362,
    ESMTPNAME = 363,
    ESMTPPASSWORD = 364,
    TRACEPOLLS = 365
  };
#endif
/* Tokens.  */
#define DEFAULTS 258
#define POLL 259
#define SKIP 260
#define VIA 261
#define AKA 262
#define LOCALDOMAINS 263
#define PROTOCOL 264
#define AUTHENTICATE 265
#define TIMEOUT 266
#define KPOP 267
#define SDPS 268
#define ENVELOPE 269
#define QVIRTUAL 270
#define PINENTRY_TIMEOUT 271
#define PWMD_SOCKET 272
#define PWMD_SOCKET_ARGS 273
#define PWMD_FILE 274
#define IDLETIMEOUT 275
#define USERNAME 276
#define PASSWORD 277
#define FOLDER 278
#define SMTPHOST 279
#define FETCHDOMAINS 280
#define MDA 281
#define BSMTP 282
#define LMTP 283
#define PASSWORDFILE 284
#define PASSWORDFD 285
#define PASSWORDEVAL 286
#define SMTPADDRESS 287
#define SMTPNAME 288
#define SPAMRESPONSE 289
#define PRECONNECT 290
#define POSTCONNECT 291
#define LIMIT 292
#define WARNINGS 293
#define INTERFACE 294
#define MONITOR 295
#define PLUGIN 296
#define PLUGOUT 297
#define IS 298
#define HERE 299
#define THERE 300
#define TO 301
#define MAP 302
#define BATCHLIMIT 303
#define FETCHLIMIT 304
#define FETCHSIZELIMIT 305
#define FASTUIDL 306
#define EXPUNGE 307
#define PROPERTIES 308
#define SET 309
#define LOGFILE 310
#define DAEMON 311
#define SYSLOG 312
#define IDFILE 313
#define PIDFILE 314
#define INVISIBLE 315
#define POSTMASTER 316
#define BOUNCEMAIL 317
#define SPAMBOUNCE 318
#define SOFTBOUNCE 319
#define SHOWDOTS 320
#define BADHEADER 321
#define ACCEPT 322
#define REJECT_ 323
#define RETRIEVEERROR 324
#define ABORT 325
#define CONTINUE 326
#define MARKSEEN 327
#define PROTO 328
#define AUTHTYPE 329
#define STRING 330
#define NUMBER 331
#define NO 332
#define KEEP 333
#define FLUSH 334
#define LIMITFLUSH 335
#define FETCHALL 336
#define REWRITE 337
#define FORCECR 338
#define STRIPCR 339
#define PASS8BITS 340
#define DROPSTATUS 341
#define DROPDELIVERED 342
#define FORCEIDLE 343
#define DNS 344
#define SERVICE 345
#define PORT 346
#define UIDL 347
#define INTERVAL 348
#define MIMEDECODE 349
#define IDLE 350
#define CHECKALIAS 351
#define SSL_ 352
#define SSLKEY 353
#define SSLCERT 354
#define SSLMODE 355
#define SSLPROTOVER 356
#define SSLCERTCK 357
#define SSLCERTFILE 358
#define SSLCERTPATH 359
#define SSLCOMMONNAME 360
#define SSLFINGERPRINT 361
#define PRINCIPAL 362
#define ESMTPNAME 363
#define ESMTPPASSWORD 364
#define TRACEPOLLS 365

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 62 "rcfile_y.y" /* yacc.c:355  */

  int proto;
  int number;
  char *sval;

#line 393 "rcfile_y.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_RCFILE_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 410 "rcfile_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   354

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  111
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  168
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  250

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   365

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    98,    98,    99,   102,   103,   106,   106,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   141,   142,   145,
     149,   150,   151,   154,   155,   158,   159,   162,   163,   166,
     167,   168,   169,   170,   180,   181,   182,   183,   191,   192,
     193,   194,   195,   198,   204,   210,   212,   214,   216,   218,
     223,   229,   230,   238,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   260,   261,   264,   265,
     268,   271,   272,   273,   276,   277,   280,   281,   284,   285,
     288,   294,   297,   298,   301,   302,   305,   306,   309,   315,
     323,   324,   325,   326,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   359,   368,   369,   370,   374,   375,   376,
     377,   378,   379,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   395,   396,   398,   399,
     400,   401,   402,   403,   404,   406,   408,   415,   422
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DEFAULTS", "POLL", "SKIP", "VIA", "AKA",
  "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE", "TIMEOUT", "KPOP", "SDPS",
  "ENVELOPE", "QVIRTUAL", "PINENTRY_TIMEOUT", "PWMD_SOCKET",
  "PWMD_SOCKET_ARGS", "PWMD_FILE", "IDLETIMEOUT", "USERNAME", "PASSWORD",
  "FOLDER", "SMTPHOST", "FETCHDOMAINS", "MDA", "BSMTP", "LMTP",
  "PASSWORDFILE", "PASSWORDFD", "PASSWORDEVAL", "SMTPADDRESS", "SMTPNAME",
  "SPAMRESPONSE", "PRECONNECT", "POSTCONNECT", "LIMIT", "WARNINGS",
  "INTERFACE", "MONITOR", "PLUGIN", "PLUGOUT", "IS", "HERE", "THERE", "TO",
  "MAP", "BATCHLIMIT", "FETCHLIMIT", "FETCHSIZELIMIT", "FASTUIDL",
  "EXPUNGE", "PROPERTIES", "SET", "LOGFILE", "DAEMON", "SYSLOG", "IDFILE",
  "PIDFILE", "INVISIBLE", "POSTMASTER", "BOUNCEMAIL", "SPAMBOUNCE",
  "SOFTBOUNCE", "SHOWDOTS", "BADHEADER", "ACCEPT", "REJECT_",
  "RETRIEVEERROR", "ABORT", "CONTINUE", "MARKSEEN", "PROTO", "AUTHTYPE",
  "STRING", "NUMBER", "NO", "KEEP", "FLUSH", "LIMITFLUSH", "FETCHALL",
  "REWRITE", "FORCECR", "STRIPCR", "PASS8BITS", "DROPSTATUS",
  "DROPDELIVERED", "FORCEIDLE", "DNS", "SERVICE", "PORT", "UIDL",
  "INTERVAL", "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL_", "SSLKEY",
  "SSLCERT", "SSLMODE", "SSLPROTOVER", "SSLCERTCK", "SSLCERTFILE",
  "SSLCERTPATH", "SSLCOMMONNAME", "SSLFINGERPRINT", "PRINCIPAL",
  "ESMTPNAME", "ESMTPPASSWORD", "TRACEPOLLS", "$accept", "rcfile",
  "statement_list", "optmap", "statement", "define_server", "serverspecs",
  "alias_list", "domain_list", "serv_option", "userspecs", "explicits",
  "explicitdef", "userdef", "user0opts", "user1opts", "mapping_list",
  "mapping", "folder_list", "smtp_list", "fetch_list", "num_list",
  "user_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365
};
# endif

#define YYPACT_NINF -126

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-126)))

#define YYTABLE_NINF -91

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      64,  -126,   -68,   -64,    97,    52,    64,  -126,  -126,  -126,
    -126,    11,    11,    11,    11,  -126,    11,    11,  -126,    11,
    -126,  -126,  -126,  -126,    66,  -126,  -126,    -5,  -126,   -10,
      44,    50,    -6,    89,    91,    96,  -126,  -126,  -126,  -126,
    -126,  -126,    98,   100,   102,    41,    53,    63,    61,   104,
     105,   106,   107,   108,   110,   111,   112,   113,   114,   120,
     121,  -126,   123,   124,   126,   127,   128,   129,   131,   132,
     148,   149,   152,   157,   158,   159,   160,   162,   163,   167,
     186,   187,   188,   190,    77,   -21,   134,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    71,
     191,  -126,   192,  -126,  -126,  -126,  -126,   195,   202,   203,
     204,  -126,   205,   206,   207,   208,   209,   210,   211,  -126,
    -126,   101,   151,  -126,  -126,   223,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,   212,  -126,   213,  -126,
    -126,  -126,  -126,  -126,  -126,   214,  -126,  -126,  -126,  -126,
    -126,    88,   -36,  -126,  -126,  -126,   215,  -126,   216,  -126,
     217,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,   218,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    18,    -4,
     136,    90,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    28,  -126,
    -126,   223,   252,  -126,  -126,  -126,  -126,  -126,   220,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    32,     0,     0,     0,     0,     3,     4,    33,    30,
      31,     7,     7,     7,     7,    20,     7,     7,    22,     7,
      13,    15,    17,    24,     0,     1,     5,    27,     6,     0,
       0,     0,     0,     0,     0,     0,    21,    23,    14,    16,
      18,    25,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   132,    66,     0,
       0,    48,     0,   130,   131,    50,   133,     0,     0,     0,
       0,   138,     0,     0,     0,     0,     0,     0,     0,    69,
      34,    28,    77,    78,    84,    76,    86,    26,    19,     8,
      11,     9,    10,    12,    40,    35,    39,    37,    41,    43,
      47,    42,    56,    57,    60,     0,    61,   166,   167,   168,
      58,    81,     0,    88,   105,    92,   109,    94,   110,    96,
     111,   115,   116,   106,   107,   108,   112,   113,    98,   114,
     118,   119,   158,   159,    62,    63,    64,    65,    90,   103,
      90,   101,   163,   160,   161,   162,   164,   165,    71,    72,
      73,    74,    75,    68,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   155,    67,    49,   153,   154,    51,
     156,   157,    70,    52,    53,    54,    55,   134,   135,   136,
     137,   139,   140,   141,   142,    44,    45,    46,     0,    29,
      79,    80,     0,    87,    36,    38,    59,    83,     0,    82,
      89,    93,    95,    97,    99,   104,   102,   100,    85,    91
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -126,  -126,  -126,    43,   170,  -126,  -126,  -126,  -126,    78,
    -126,  -126,    82,  -126,  -126,  -126,    92,   -30,  -126,  -126,
    -126,  -126,  -125
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    29,     7,     8,    27,   136,   138,   120,
     121,   122,   123,   124,   231,   125,   152,   153,   156,   158,
     160,   169,   126
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     233,    42,    43,    44,    45,    46,    47,     9,   239,    48,
      49,    10,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,   180,
     246,    77,   193,    78,    79,    80,    81,    82,    83,   190,
     191,   192,    25,   139,   140,    30,    31,    32,    28,    33,
      34,    84,    35,   245,    85,   238,   127,     1,     2,     3,
     130,   180,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   248,    42,    43,    44,
      45,    46,    47,    11,   141,    48,    49,   205,     4,   128,
     206,    53,   240,    36,   209,   129,    37,   142,    38,    39,
      40,    41,   -90,   237,   247,   238,   144,   145,   212,   143,
      72,    73,    74,    75,   188,   189,   213,   214,   193,   240,
      12,   240,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,   -90,   131,   180,   132,    84,   179,   181,
      85,   133,    54,   134,    24,   135,    26,   137,   228,   146,
     147,   148,   149,   238,   150,   151,   154,   155,   157,   159,
      98,    99,   100,   101,   102,   161,   162,   105,   163,   229,
     164,   165,   166,   167,   230,   168,   170,   171,   116,   117,
     118,   119,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   172,   173,   206,   174,   207,   208,
     209,   210,   175,   176,   177,   178,   211,   180,     0,   182,
      50,    51,    52,   183,   212,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,   184,   185,   186,   187,    76,   215,   216,    77,
     217,    78,    79,    80,    81,    82,    83,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   234,   235,   236,
     241,   242,   243,     0,   244,   249,     0,     0,     0,     0,
     232,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,     0,     0,     0,     0,     0,   103,   104,     0,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,     0,     0,     0,     0,     0,   207,   208,     0,   210,
       0,     0,     0,     0,   211
};

static const yytype_int16 yycheck[] =
{
     125,     6,     7,     8,     9,    10,    11,    75,    44,    14,
      15,    75,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    75,
      44,    46,    14,    48,    49,    50,    51,    52,    53,    70,
      71,    72,     0,    12,    13,    12,    13,    14,    47,    16,
      17,    66,    19,    45,    69,    47,    76,     3,     4,     5,
      76,    75,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   231,     6,     7,     8,
       9,    10,    11,    16,    73,    14,    15,    89,    54,    75,
      92,    20,   152,    57,    96,    75,    60,    74,    62,    63,
      64,    65,    44,    45,    44,    47,    75,    76,   110,    76,
      39,    40,    41,    42,    67,    68,    75,    76,    14,   179,
      53,   181,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    75,    75,    75,    75,    66,    76,    77,
      69,    75,    21,    75,    77,    75,     6,    75,    77,    75,
      75,    75,    75,    47,    76,    75,    75,    75,    75,    75,
      89,    90,    91,    92,    93,    75,    75,    96,    75,   121,
      76,    75,    75,    75,   122,    76,    75,    75,   107,   108,
     109,   110,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    76,    76,    92,    75,    94,    95,
      96,    97,    75,    75,    75,    75,   102,    75,    -1,    76,
      17,    18,    19,    76,   110,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    76,    76,    76,    75,    43,    76,    76,    46,
      75,    48,    49,    50,    51,    52,    53,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    -1,    76,    75,    -1,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,
      -1,    -1,    -1,    -1,   102
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    54,   112,   113,   115,   116,    75,
      75,    16,    53,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    77,     0,   115,   117,    47,   114,
     114,   114,   114,   114,   114,   114,    57,    60,    62,    63,
      64,    65,     6,     7,     8,     9,    10,    11,    14,    15,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    46,    48,    49,
      50,    51,    52,    53,    66,    69,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     120,   121,   122,   123,   124,   126,   133,    76,    75,    75,
      76,    75,    75,    75,    75,    75,   118,    75,   119,    12,
      13,    73,    74,    76,    75,    76,    75,    75,    75,    75,
      76,    75,   127,   128,    75,    75,   129,    75,   130,    75,
     131,    75,    75,    75,    76,    75,    75,    75,    76,   132,
      75,    75,    76,    76,    75,    75,    75,    75,    75,   127,
      75,   127,    76,    76,    76,    76,    76,    75,    67,    68,
      70,    71,    72,    14,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    92,    94,    95,    96,
      97,   102,   110,    75,    76,    76,    76,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    77,   120,
     123,   125,    77,   133,    75,    75,    75,    45,    47,    44,
     128,    75,    75,    75,    76,    45,    44,    44,   133,    75
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   111,   112,   112,   113,   113,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     116,   116,   116,   117,   117,   118,   118,   119,   119,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   121,   121,   122,   122,
     123,   124,   124,   124,   125,   125,   126,   126,   127,   127,
     128,   128,   129,   129,   130,   130,   131,   131,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     0,     4,     4,
       4,     4,     4,     2,     3,     2,     3,     2,     3,     4,
       2,     3,     2,     3,     2,     3,     4,     2,     3,     4,
       2,     2,     1,     0,     2,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       2,     2,     3,     3,     0,     2,     1,     2,     1,     2,
       1,     3,     1,     2,     1,     2,     1,     2,     1,     2,
       3,     2,     3,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 75: /* STRING  */
#line 94 "rcfile_y.y" /* yacc.c:1257  */
      { free (((*yyvaluep).sval)); }
#line 1461 "rcfile_y.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:
#line 109 "rcfile_y.y" /* yacc.c:1646  */
    {run.logfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1725 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 9:
#line 110 "rcfile_y.y" /* yacc.c:1646  */
    {run.idfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1731 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 10:
#line 111 "rcfile_y.y" /* yacc.c:1646  */
    {run.pidfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1737 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 11:
#line 112 "rcfile_y.y" /* yacc.c:1646  */
    {run.poll_interval = (yyvsp[0].number);}
#line 1743 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 12:
#line 113 "rcfile_y.y" /* yacc.c:1646  */
    {run.postmaster = (yyvsp[0].sval);}
#line 1749 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 13:
#line 114 "rcfile_y.y" /* yacc.c:1646  */
    {run.bouncemail = TRUE;}
#line 1755 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 14:
#line 115 "rcfile_y.y" /* yacc.c:1646  */
    {run.bouncemail = FALSE;}
#line 1761 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 15:
#line 116 "rcfile_y.y" /* yacc.c:1646  */
    {run.spambounce = TRUE;}
#line 1767 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 16:
#line 117 "rcfile_y.y" /* yacc.c:1646  */
    {run.spambounce = FALSE;}
#line 1773 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 17:
#line 118 "rcfile_y.y" /* yacc.c:1646  */
    {run.softbounce = TRUE;}
#line 1779 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 18:
#line 119 "rcfile_y.y" /* yacc.c:1646  */
    {run.softbounce = FALSE;}
#line 1785 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 19:
#line 120 "rcfile_y.y" /* yacc.c:1646  */
    {run.properties = (yyvsp[0].sval);}
#line 1791 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 20:
#line 121 "rcfile_y.y" /* yacc.c:1646  */
    {run.use_syslog = TRUE;}
#line 1797 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 21:
#line 122 "rcfile_y.y" /* yacc.c:1646  */
    {run.use_syslog = FALSE;}
#line 1803 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 22:
#line 123 "rcfile_y.y" /* yacc.c:1646  */
    {run.invisible = TRUE;}
#line 1809 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 23:
#line 124 "rcfile_y.y" /* yacc.c:1646  */
    {run.invisible = FALSE;}
#line 1815 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 24:
#line 125 "rcfile_y.y" /* yacc.c:1646  */
    {run.showdots = FLAG_TRUE;}
#line 1821 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 126 "rcfile_y.y" /* yacc.c:1646  */
    {run.showdots = FLAG_FALSE;}
#line 1827 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 26:
#line 127 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef HAVE_LIBPWMD
		    run.pinentry_timeout = (yyvsp[0].number);
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
		    }
#line 1839 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 27:
#line 141 "rcfile_y.y" /* yacc.c:1646  */
    {record_current();}
#line 1845 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 29:
#line 146 "rcfile_y.y" /* yacc.c:1646  */
    {yyerror(GT_("server option after user options"));}
#line 1851 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 30:
#line 149 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server((yyvsp[0].sval), FALSE); free((yyvsp[0].sval));}
#line 1857 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 31:
#line 150 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server((yyvsp[0].sval), TRUE);  free((yyvsp[0].sval));}
#line 1863 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 32:
#line 151 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server("defaults", FALSE);}
#line 1869 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 35:
#line 158 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1875 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 36:
#line 159 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1881 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 37:
#line 162 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1887 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 38:
#line 163 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1893 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 40:
#line 167 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.via = (yyvsp[0].sval);}
#line 1899 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 42:
#line 169 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.protocol = (yyvsp[0].proto);}
#line 1905 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 43:
#line 170 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.protocol = P_POP3;
#ifdef KERBEROS_V5
					    if (current.server.authenticate == A_PASSWORD)
						current.server.authenticate = A_KERBEROS_V5;
					    current.server.service = KPOP_PORT;
#else
					    yyerror(GT_("Kerberos not enabled."));
#endif
					}
#line 1920 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 44:
#line 180 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.principal = (yyvsp[0].sval);}
#line 1926 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 45:
#line 181 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.esmtp_name = (yyvsp[0].sval);}
#line 1932 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 46:
#line 182 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.esmtp_password = (yyvsp[0].sval);}
#line 1938 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 183 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
#line 1951 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 48:
#line 191 "rcfile_y.y" /* yacc.c:1646  */
    {/* EMPTY - removed in 7.0.0 */}
#line 1957 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 49:
#line 192 "rcfile_y.y" /* yacc.c:1646  */
    {/* EMPTY - removed in 7.0.0 */}
#line 1963 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 50:
#line 193 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.checkalias = FLAG_TRUE;}
#line 1969 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 194 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.checkalias  = FLAG_FALSE;}
#line 1975 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 195 "rcfile_y.y" /* yacc.c:1646  */
    {
					current.server.service = (yyvsp[0].sval);
					}
#line 1983 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 53:
#line 198 "rcfile_y.y" /* yacc.c:1646  */
    {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 1994 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 54:
#line 204 "rcfile_y.y" /* yacc.c:1646  */
    {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 2005 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 55:
#line 211 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.interval = (yyvsp[0].number);}
#line 2011 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 213 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.authenticate = (yyvsp[0].proto);}
#line 2017 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 57:
#line 215 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.timeout = (yyvsp[0].number);}
#line 2023 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 58:
#line 217 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.idle_timeout = (yyvsp[0].number);}
#line 2029 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 219 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = (yyvsp[-1].number);
					}
#line 2038 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 60:
#line 224 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = 0;
					}
#line 2047 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 61:
#line 229 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.qvirtual = (yyvsp[0].sval);}
#line 2053 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 62:
#line 230 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef CAN_MONITOR
					interface_parse((yyvsp[0].sval), &current.server);
#else
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif
					free((yyvsp[0].sval));
					}
#line 2066 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 63:
#line 238 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef CAN_MONITOR
					current.server.monitor = (yyvsp[0].sval);
#else
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
					free((yyvsp[0].sval));
#endif
					}
#line 2079 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 64:
#line 246 "rcfile_y.y" /* yacc.c:1646  */
    { current.server.plugin = (yyvsp[0].sval); }
#line 2085 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 65:
#line 247 "rcfile_y.y" /* yacc.c:1646  */
    { current.server.plugout = (yyvsp[0].sval); }
#line 2091 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 66:
#line 248 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.dns = FLAG_TRUE;}
#line 2097 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 249 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.dns = FLAG_FALSE;}
#line 2103 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 68:
#line 250 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.envelope = STRING_DISABLED;}
#line 2109 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 69:
#line 251 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.tracepolls = FLAG_TRUE;}
#line 2115 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 70:
#line 252 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.tracepolls = FLAG_FALSE;}
#line 2121 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 71:
#line 253 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.badheader = BHACCEPT;}
#line 2127 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 72:
#line 254 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.badheader = BHREJECT;}
#line 2133 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 73:
#line 255 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.retrieveerror = RE_ABORT;}
#line 2139 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 74:
#line 256 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.retrieveerror = RE_CONTINUE;}
#line 2145 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 75:
#line 257 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.retrieveerror = RE_MARKSEEN;}
#line 2151 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 76:
#line 260 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2157 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 78:
#line 264 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2163 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 79:
#line 265 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2169 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 81:
#line 271 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename = (yyvsp[0].sval);}
#line 2175 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 83:
#line 273 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename = (yyvsp[-1].sval);}
#line 2181 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 90:
#line 288 "rcfile_y.y" /* yacc.c:1646  */
    {if (0 == strcmp((yyvsp[0].sval), "*")) {
					      current.wildcard = TRUE;
					  } else {
					    save_str_pair(&current.localnames, (yyvsp[0].sval), NULL);
					  }
					 free((yyvsp[0].sval));}
#line 2192 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 91:
#line 294 "rcfile_y.y" /* yacc.c:1646  */
    {save_str_pair(&current.localnames, (yyvsp[-2].sval), (yyvsp[0].sval)); free((yyvsp[-2].sval)); free((yyvsp[0].sval));}
#line 2198 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 92:
#line 297 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2204 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 93:
#line 298 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2210 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 94:
#line 301 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2216 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 95:
#line 302 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2222 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 96:
#line 305 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2228 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 97:
#line 306 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2234 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 98:
#line 310 "rcfile_y.y" /* yacc.c:1646  */
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2244 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 99:
#line 316 "rcfile_y.y" /* yacc.c:1646  */
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2254 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 104:
#line 328 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename  = (yyvsp[-1].sval);}
#line 2260 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 105:
#line 329 "rcfile_y.y" /* yacc.c:1646  */
    {current.password    = (yyvsp[0].sval);}
#line 2266 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 106:
#line 330 "rcfile_y.y" /* yacc.c:1646  */
    {current.passwordfile = (yyvsp[0].sval);}
#line 2272 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 107:
#line 331 "rcfile_y.y" /* yacc.c:1646  */
    {current.passwordfd  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2278 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 108:
#line 332 "rcfile_y.y" /* yacc.c:1646  */
    {current.passwordeval = (yyvsp[0].sval); }
#line 2284 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 112:
#line 336 "rcfile_y.y" /* yacc.c:1646  */
    {current.smtpaddress = (yyvsp[0].sval);}
#line 2290 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 113:
#line 337 "rcfile_y.y" /* yacc.c:1646  */
    {current.smtpname =    (yyvsp[0].sval);}
#line 2296 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 115:
#line 339 "rcfile_y.y" /* yacc.c:1646  */
    {current.mda         = (yyvsp[0].sval);}
#line 2302 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 116:
#line 340 "rcfile_y.y" /* yacc.c:1646  */
    {current.bsmtp       = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2308 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 117:
#line 341 "rcfile_y.y" /* yacc.c:1646  */
    {current.listener    = LMTP_MODE;}
#line 2314 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 118:
#line 342 "rcfile_y.y" /* yacc.c:1646  */
    {current.preconnect  = (yyvsp[0].sval);}
#line 2320 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 119:
#line 343 "rcfile_y.y" /* yacc.c:1646  */
    {current.postconnect = (yyvsp[0].sval);}
#line 2326 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 120:
#line 345 "rcfile_y.y" /* yacc.c:1646  */
    {current.keep        = FLAG_TRUE;}
#line 2332 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 121:
#line 346 "rcfile_y.y" /* yacc.c:1646  */
    {current.flush       = FLAG_TRUE;}
#line 2338 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 122:
#line 347 "rcfile_y.y" /* yacc.c:1646  */
    {current.limitflush  = FLAG_TRUE;}
#line 2344 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 123:
#line 348 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchall    = FLAG_TRUE;}
#line 2350 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 124:
#line 349 "rcfile_y.y" /* yacc.c:1646  */
    {current.rewrite     = FLAG_TRUE;}
#line 2356 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 125:
#line 350 "rcfile_y.y" /* yacc.c:1646  */
    {current.forcecr     = FLAG_TRUE;}
#line 2362 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 126:
#line 351 "rcfile_y.y" /* yacc.c:1646  */
    {current.stripcr     = FLAG_TRUE;}
#line 2368 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 127:
#line 352 "rcfile_y.y" /* yacc.c:1646  */
    {current.pass8bits   = FLAG_TRUE;}
#line 2374 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 128:
#line 353 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropstatus  = FLAG_TRUE;}
#line 2380 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 129:
#line 354 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropdelivered = FLAG_TRUE;}
#line 2386 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 130:
#line 355 "rcfile_y.y" /* yacc.c:1646  */
    {current.mimedecode  = FLAG_TRUE;}
#line 2392 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 131:
#line 356 "rcfile_y.y" /* yacc.c:1646  */
    {current.idle        = FLAG_TRUE;}
#line 2398 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 132:
#line 357 "rcfile_y.y" /* yacc.c:1646  */
    {current.forceidle   = FLAG_TRUE;}
#line 2404 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 133:
#line 359 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef SSL_ENABLE
		    current.sslmode = TLSM_WRAPPED;
		    if (outlevel > O_SILENT)
		    yywarn(GT_("WARNING: ssl is obsolescent. Please use sslmode wrapped instead."));
#else
		    yyerror(GT_("SSL is not enabled"));
#endif 
		}
#line 2418 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 134:
#line 368 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslkey = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2424 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 135:
#line 369 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcert = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2430 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 136:
#line 370 "rcfile_y.y" /* yacc.c:1646  */
    {e_sslmode e = tlsm_parse((yyvsp[0].sval));
					 if (e != TLSM_INVALID) current.sslmode = e;
					 else yyerror(GT_("Invalid sslmode specified."));
					 free((yyvsp[0].sval)); }
#line 2439 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 137:
#line 374 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslproto = (yyvsp[0].sval);}
#line 2445 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 138:
#line 375 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertck = FLAG_TRUE;}
#line 2451 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 139:
#line 376 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertfile = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2457 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 140:
#line 377 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertpath = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2463 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 141:
#line 378 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcommonname = (yyvsp[0].sval);}
#line 2469 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 142:
#line 379 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslfingerprint = (yyvsp[0].sval);}
#line 2475 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 143:
#line 381 "rcfile_y.y" /* yacc.c:1646  */
    {current.keep        = FLAG_FALSE;}
#line 2481 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 144:
#line 382 "rcfile_y.y" /* yacc.c:1646  */
    {current.flush       = FLAG_FALSE;}
#line 2487 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 145:
#line 383 "rcfile_y.y" /* yacc.c:1646  */
    {current.limitflush  = FLAG_FALSE;}
#line 2493 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 146:
#line 384 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchall    = FLAG_FALSE;}
#line 2499 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 147:
#line 385 "rcfile_y.y" /* yacc.c:1646  */
    {current.rewrite     = FLAG_FALSE;}
#line 2505 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 148:
#line 386 "rcfile_y.y" /* yacc.c:1646  */
    {current.forcecr     = FLAG_FALSE;}
#line 2511 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 149:
#line 387 "rcfile_y.y" /* yacc.c:1646  */
    {current.stripcr     = FLAG_FALSE;}
#line 2517 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 150:
#line 388 "rcfile_y.y" /* yacc.c:1646  */
    {current.pass8bits   = FLAG_FALSE;}
#line 2523 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 151:
#line 389 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropstatus  = FLAG_FALSE;}
#line 2529 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 152:
#line 390 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropdelivered = FLAG_FALSE;}
#line 2535 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 153:
#line 391 "rcfile_y.y" /* yacc.c:1646  */
    {current.mimedecode  = FLAG_FALSE;}
#line 2541 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 154:
#line 392 "rcfile_y.y" /* yacc.c:1646  */
    {current.idle        = FLAG_FALSE;}
#line 2547 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 155:
#line 393 "rcfile_y.y" /* yacc.c:1646  */
    {current.forceidle   = FLAG_FALSE;}
#line 2553 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 156:
#line 395 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslmode     = TLSM_NONE;}
#line 2559 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 157:
#line 396 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertck   = FLAG_FALSE;}
#line 2565 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 158:
#line 398 "rcfile_y.y" /* yacc.c:1646  */
    {current.limit       = NUM_VALUE_IN((yyvsp[0].number));}
#line 2571 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 159:
#line 399 "rcfile_y.y" /* yacc.c:1646  */
    {current.warnings    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2577 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 160:
#line 400 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2583 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 161:
#line 401 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchsizelimit = NUM_VALUE_IN((yyvsp[0].number));}
#line 2589 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 162:
#line 402 "rcfile_y.y" /* yacc.c:1646  */
    {current.fastuidl    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2595 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 163:
#line 403 "rcfile_y.y" /* yacc.c:1646  */
    {current.batchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2601 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 164:
#line 404 "rcfile_y.y" /* yacc.c:1646  */
    {current.expunge     = NUM_VALUE_IN((yyvsp[0].number));}
#line 2607 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 165:
#line 406 "rcfile_y.y" /* yacc.c:1646  */
    {current.properties  = (yyvsp[0].sval);}
#line 2613 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 166:
#line 408 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef HAVE_LIBPWMD
		    current.pwmd_socket = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2625 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 167:
#line 415 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef HAVE_LIBPWMD
		    current.pwmd_socket_args = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2637 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 168:
#line 422 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef HAVE_LIBPWMD
		    current.pwmd_file = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2649 "rcfile_y.c" /* yacc.c:1646  */
    break;


#line 2653 "rcfile_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 430 "rcfile_y.y" /* yacc.c:1906  */


static struct query *hosttail;	/* where to add new elements */

/** check that a configuration file is secure, returns PS_* status codes */
int prc_filecheck(const char *pathname,
		  const flag securecheck /** shortcuts permission, filetype and uid tests if false */)
{
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this 
       process, it must have permissions no greater than 600, and it must not 
       be a symbolic link.  We check these conditions here. */

    if (stat(pathname, &statbuf) < 0) {
	if (errno == ENOENT) 
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if (!S_ISREG(statbuf.st_mode))
    {
	fprintf(stderr, GT_("File %s must be a regular file.\n"), pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXOTH))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx------ (0700) permissions.\n"), 
		pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_uid != geteuid())
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    yyparse();		/* parse entire file */

    if (yyin != stdin)
       fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag) 
	return(PS_SYNTAX);
    else
	return(PS_SUCCESS);
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
    current.server.principal = (char *)NULL;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;

    current.server = save;
}

/** append a host record to the host list */
struct query *hostalloc(struct query *init /** pointer to block containing
					       initial values */)
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
	node->passwordfd = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = (char *)xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* rcfile_y.y ends here */
